| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Classes | Enumerations | Functions
Cascade Classifier for Object Detection
Object Detection

## Detailed Description

The object detector described below has been initially proposed by Paul Viola [286] and improved by Rainer Lienhart [168] .

First, a classifier (namely a cascade of boosted classifiers working with haar-like features) is trained with a few hundred sample views of a particular object (i.e., a face or a car), called positive examples, that are scaled to the same size (say, 20x20), and negative examples - arbitrary images of the same size.

After a classifier is trained, it can be applied to a region of interest (of the same size as used during the training) in an input image. The classifier outputs a "1" if the region is likely to show the object (i.e., face/car), and "0" otherwise. To search for the object in the whole image one can move the search window across the image and check every location using the classifier. The classifier is designed so that it can be easily "resized" in order to be able to find the objects of interest at different sizes, which is more efficient than resizing the image itself. So, to find an object of an unknown size in the image the scan procedure should be done several times at different scales.

The word "cascade" in the classifier name means that the resultant classifier consists of several simpler classifiers (stages) that are applied subsequently to a region of interest until at some stage the candidate is rejected or all the stages are passed. The word "boosted" means that the classifiers at every stage of the cascade are complex themselves and they are built out of basic classifiers using one of four different boosting techniques (weighted voting). Currently Discrete Adaboost, Real Adaboost, Gentle Adaboost and Logitboost are supported. The basic classifiers are decision-tree classifiers with at least 2 leaves. Haar-like features are the input to the basic classifiers, and are calculated as described below. The current algorithm uses the following Haar-like features:

image

The feature used in a particular classifier is specified by its shape (1a, 2b etc.), position within the region of interest and the scale (this scale is not the same as the scale used at the detection stage, though these two scales are multiplied). For example, in the case of the third line feature (2c) the response is calculated as the difference between the sum of image pixels under the rectangle covering the whole feature (including the two white stripes and the black stripe in the middle) and the sum of the image pixels under the black stripe multiplied by 3 in order to compensate for the differences in the size of areas. The sums of pixel values over a rectangular regions are calculated rapidly using integral images (see below and the integral description).

Check the corresponding tutorial for more details.

The following reference is for the detection part only. There is a separate application called opencv_traincascade that can train a cascade of boosted classifiers from a set of samples.

Note
  In the new C++ interface it is also possible to use LBP (local binary pattern) features in addition to Haar-like features. .. [Viola01] Paul Viola and Michael J. Jones. Rapid Object Detection using a Boosted Cascade of Simple Features. IEEE CVPR, 2001. The paper is available online at https://github.com/SvHey/thesis/blob/master/Literature/ObjectDetection/violaJones_CVPR2001.pdf

## Classes
class | cv::BaseCascadeClassifier
class | cv::CascadeClassifier
| Cascade classifier class for object detection. More...
struct | cv::DefaultDeleter< CvHaarClassifierCascade >
class | cv::DetectionBasedTracker

## Enumerations
enum | { cv::CASCADE_DO_CANNY_PRUNING = 1 , cv::CASCADE_SCALE_IMAGE = 2 , cv::CASCADE_FIND_BIGGEST_OBJECT = 4 , cv::CASCADE_DO_ROUGH_SEARCH = 8 }

## Functions
Ptr< BaseCascadeClassifier::MaskGenerator > | cv::createFaceDetectionMaskGenerator ()

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

`#include <opencv2/xobjdetect.hpp>`

Enumerator
CASCADE_DO_CANNY_PRUNING Python: cv.CASCADE_DO_CANNY_PRUNING |
CASCADE_SCALE_IMAGE Python: cv.CASCADE_SCALE_IMAGE |
CASCADE_FIND_BIGGEST_OBJECT Python: cv.CASCADE_FIND_BIGGEST_OBJECT |
CASCADE_DO_ROUGH_SEARCH Python: cv.CASCADE_DO_ROUGH_SEARCH |

## Function Documentation

## ◆ createFaceDetectionMaskGenerator()

Ptr< BaseCascadeClassifier::MaskGenerator > cv::createFaceDetectionMaskGenerator | ( |  | ) |

`#include <opencv2/xobjdetect.hpp>`